###############################################################################
# Karma.pl - YaBB Mod by Joseph Fung (Joseph@ComESutra.ORg)                   #
# SP1 version by Matthew Throesch (mthroesch@hotmail.com                      #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Project started by Zef Hemel (zef@zefnet.com)                   #
# Software Version: YaBB SP1.3/1.3.1                                          #
###############################################################################
# Version 1.1b - Iceberg (viceberg@inbox.ru)                                  #
# Last modification: 4th of may, 2003                                         #
###############################################################################
sub getKarma {
  $sourceUser = shift;
  @karma = &getKarmaData($sourceUser);
  $karma[0] =~ s/[\n\r]//g;
  return $karma[0];
}

sub setKarma {
  $sourceUser = shift;
  $newKarmaValue = shift;
  @karma = &getKarmaData($sourceUser);
  $karma[0] = "$newKarmaValue\n";
  open(FILE, ">$memberdir/$sourceUser.karma");
  foreach $line (@karma){ print FILE "$line"; }
  close(FILE);
}

sub isInMemberGroup {
  my ($inMemberGroup) = 0;
  if ($karmaAllowedMemberGroups eq ''){ $inMemberGroup = 1; }
  my (@karmaGroups) = split(/,/, $karmaAllowedMemberGroups);
  foreach $karmaGroup (@karmaGroups){
    if ($settings[7] eq $karmaGroup) { $inMemberGroup = 1; }
  }
  return $inMemberGroup;
}

sub modifyKarma{
  if ($username eq "Guest"){ &fatal_error($karmatxt{'4'}); }

  if ($settings[6] < $karmaMinPosts) { &fatal_error($karmatxt{'5'}); }

  $sourceUserID = $INFO{'username'};
  if ($sourceUserID eq $username) { &fatal_error($karmatxt{'6'}); }

  my($inMemberGroup) = &isInMemberGroup;
  if ($inMemberGroup == 0){ &fatal_error($karmatxt{'7'}); }

  $desiredAction = $INFO{'karmaAction'};
  @thekarma = &getKarmaData($username);
  $modifiedEntry = -1;
  $newTimestamp = time;
  for ($i = 1; $i < scalar @thekarma; $i++){
    ($targetUser, $targetAction, $timestamp) = split (/\|/, $thekarma[$i]);
    if ($targetUser eq $sourceUserID){
      $modifiedEntry = $i;
      $timestamp =~ s/[\n\r]//g;
      if (($newTimestamp-$timestamp) < $waitTime){
        if ($desiredAction eq $targetAction && (($settings[7] ne 'Administrator') || $settings[7] eq 'Administrator' && $restrictAdmin == 1)){
          &fatal_error($karmatxt{'8'});
        }else {
          $newKarma = &getKarma ($sourceUserID);
          if ($settings[7] ne 'Administrator'){
            if ($desiredAction eq "smite"){ $newKarma = $newKarma -2; }
            elsif ($desiredAction eq "applaud"){ $newKarma = $newKarma +2; }
          } else {
            if ($desiredAction eq "smite"){ $newKarma = $newKarma -1; }
            elsif ($desiredAction eq "applaud"){ $newKarma = $newKarma +1; }
          }
	  &setKarma ($sourceUserID, $newKarma);
        }   
      }else {
        $newKarma = &getKarma ($sourceUserID);
        if ($desiredAction eq "smite"){ $newKarma = $newKarma -1; }
        elsif ($desiredAction eq "applaud"){ $newKarma = $newKarma +1; }
	&setKarma ($sourceUserID, $newKarma);
      }
    }
  }
  if ($modifiedEntry == -1){
    $modifiedEntry = scalar @thekarma;
    $newKarma = &getKarma ($sourceUserID);
    if ($desiredAction eq "smite"){
      $newKarma = $newKarma -1;
    } elsif ($desiredAction eq "applaud"){
        $newKarma = $newKarma+ 1;
    }
    &setKarma ($sourceUserID, $newKarma);
  }
  @thekarma[$modifiedEntry] = "$sourceUserID|$desiredAction|$newTimestamp\n";
  open(FILE, ">$memberdir/$username.karma");
  foreach $line (@thekarma){ print FILE $line; }
  close(FILE);
  &yabb_alert ($karmatxt{'9'});
}

sub getKarmaData {
  $sourceUser = shift;
  if(-e("$memberdir/$sourceUser.karma")){
    open(FILE, "$memberdir/$sourceUser.karma");
    @karma = <FILE>;
    close(FILE);
  }else {
    @karma = ("0\n");
  }
  return @karma;
}
1;
